<template lang="pug">
  div.bg-light-gray.min-vh-100
    div(v-if="isAuthenticated")
      sidebar.z-1
      main.pl7-l.pt5.pt0-l
        nuxt/
    .flex.flex-column.justify-center.items-center.vh-100(v-if="canLogin")
      b-button(@click="login" size="is-large" type="is-success") 登入
      .pa3.f6(v-if="authErrorEmail")
        | 使用 Google 登入嗎？請聯絡管理員，將 {{authErrorEmail}} 加入清單裡
    b-loading(:active="isWaiting")
</template>
<script>
import Sidebar from '~/components/Sidebar'

export default {
  components: {
    Sidebar
  },
  computed: {
    isAuthenticated () {
      if (!this.$auth) {
        // if in server side
        return false
      } else if (this.$auth.fake) {
        // if auth0 is disabled
        return true
      }
      if (this.$auth.loading) {
        return false
      }
      return this.$auth.isAuthenticated
    },
    canLogin () {
      return !this.isAuthenticated && this.$auth && !this.$auth.loading
    },
    isWaiting () {
      return !this.isAuthenticated && !this.canLogin
    },
    authErrorEmail () {
      if (!this.isWaiting && this.$auth && this.$auth.error) {
        const desp = this.$route.query.error_description
        const email = desp ? desp.split(' - ').slice(1).join(' - ') : ''
        return email
      }
      return ''
    }
  },
  methods: {
    login () {
      this.$auth.loginWithRedirect()
    }
  }
}
</script>
<style lang="scss">
html {
  overflow: auto;
}
</style>
